////////////////////////////////////////////////////////////////////////////////
//	検索ボックスガジェット
//		Copyright (C) 2008 - 2009 AAOh inc.
////////////////////////////////////////////////////////////////////////////////

// 設定情報(JSON)
var settingData = {
	"bg"                  : "onDoc1",
	"searchEngineDefault" : "googleJp",
	"suggest"             : true,
	"flyout"              : false,
	"lang"                : "ja",
	"chkUpdTime"          : 0,
	"chkUpdUrl"           : null
};

var suggestIid        = null;
var suggestTime       = 500;
var tmpKeyward        = null;
var flgSelSuggest     = false;
var selSuggestMaxSize = 10;
var suggestHeight     = 13;

var flgOnDoc = true;

var updChkIid = null;

/**
 * エスケープした文字列を取得します。
 *
 * @param charset 文字コード
 * @param value   エスケープする文字列
 */
function getEscapeValue(charset, value){
	var escapeValue = null;

	switch(charset){
		case "shift_jis":
			escapeValue = EscapeSJIS(value);
			break;

		case "euc-jp":
			escapeValue = EscapeEUCJP(value);
			break;

		case "jis":
			escapeValue = EscapeJIS8(value);
			break;

		case "utf-8":
		default:
			escapeValue = EscapeUTF8(value);
			break;
	}

	return escapeValue;
}

/**
 * 検索実行。
 */
function doSearch(){
	if(suggestIid != null){
		clearTimeout(suggestIid);
		suggestIid = null;
	}

	// 検索キーワードの取得
	var keyward = $("txt_search").value;

	// パラメータの作成
	var param        = null;
	var searchEndine = $("sel_search_engine").value;
	if(keyward == ""){
		// デフォルトページへ移動
		param = SEARCH_LIST.engine[searchEndine].url;

	} else {
		// 検索ページへ移動
		var value = getEscapeValue(SEARCH_LIST.engine[searchEndine].charset, keyward);
		param = SEARCH_LIST.engine[searchEndine].searchUrl + value;
	}

	// 検索実行
	tmpKeyward = null;
	showSearch(param);

	tmpKeyInput = keyward;
}

/**
 * サジェスト検索。
 */
function doSuggestSearch(){
	// サジェスト検索off
	if(!settingData.suggest){
		// 何もしない
		return;
	}

	// 対象サジェストURLなし
	var searchEndine = $("sel_search_engine").value;
	var suggestUrl   = SEARCH_LIST.engine[searchEndine].suggestUrl;
	if(suggestUrl == null || suggestUrl == ""){
		// 何もしない
		return;
	}

	// 検索キーワードの取得
	var keyward = $("txt_search").value;
	if(keyward == ""){
		// サジェスト表示のクリア
		clearSuggest();
		return;
	}

	// 一定時間過ぎたらサジェスト検索
	if(suggestIid != null){
		//clearTimeout(suggestIid);
	}
	suggestIid = setTimeout("doSuggestSearch2()", suggestTime);
}

/**
 * サジェスト検索。
 */
function doSuggestSearch2(){
	suggestIid = null;

	var keyward = $("txt_search").value;
	if(tmpKeyward != null && tmpKeyward == keyward){
		// 何もしない
		return;
	}

	// パラメータの作成
	var searchEndine = $("sel_search_engine").value;
	var suggestUrl   = SEARCH_LIST.engine[searchEndine].suggestUrl;
	var value        = getEscapeValue(SEARCH_LIST.engine[searchEndine].charset, keyward);
	var param        = suggestUrl + value;

	// サジェスト検索実行
	doUpdateSuggest(param);
	tmpKeyward = keyward;
}

/**
 * サジェスト表示のクリア。
 */
function clearSuggest(){
	tmpKeyward = null;

	// サジェスト検索off
	if(!settingData.suggest){
		// 何もしない
		return;
	}

	// サジェスト表示のクリア
	showUnFlyout();
}

/**
 * サジェスト表示。
 *
 * @param suggestList サジェストデータ
 */
function showSuggest(suggestList){
	// 検索キーワードの取得
	var keyward = $("txt_search").value;
	if(
		keyward == ""
		|| (tmpKeyward != null && tmpKeyward == keyward)
	){
		// 何もしない
		showSuggestNone();
		return;
	}

	// 更新イメージを戻す
	var imgUpd = $("img_access");
	imgUpd.src   = IMG_SRC_ACCESS_NON;
	imgUpd.alt   = getLocalizedString("IMG_ALT_ACCESS_NON");
	imgUpd.title = getLocalizedString("IMG_ALT_ACCESS_NON");

	// サジェスト初期化
	var selSuggest = $("sel_suggest");
	var len        = selSuggest.length;
	for(var cnt = 0 ; cnt < len ; cnt++){
		selSuggest.remove(0);
	}

	// サジェスト追加
	for(var cnt = 0 ; cnt < suggestList.length ; cnt++){
		var optionObj = document.createElement("option");
		var value     = suggestList[cnt];
		optionObj.innerHTML = value;
		optionObj.value     = value;
		selSuggest.appendChild(optionObj);
	}
	selSuggest.size = Math.min(selSuggestMaxSize, suggestList.length);

	// サジェスト表示
	showOnFlyout();
}

/**
 * サジェスト表示。
 */
function showSuggestNone(){
	// 更新イメージを戻す
	var imgUpd = $("img_access");
	imgUpd.src   = IMG_SRC_ACCESS_NON;
	imgUpd.alt   = getLocalizedString("IMG_ALT_ACCESS_NON");
	imgUpd.title = getLocalizedString("IMG_ALT_ACCESS_NON");

	clearSuggest();
}

/**
 * サジェスト検索。
 *
 * @param param 検索パラメータ
 */
function doUpdateSuggest(param){
	// Firefox対応
	try{
		if(netscape){
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		}
	}catch (ex){
	}

	// 更新イメージをチェック中にする
	var imgUpd = $("img_access");
	imgUpd.src   = IMG_SRC_ACCESS_NOW;
	imgUpd.alt   = getLocalizedString("IMG_ALT_ACCESS_NOW");
	imgUpd.title = getLocalizedString("IMG_ALT_ACCESS_NOW");

/*
	var updSuggestReq = new Ajax.Request(
		param, {
			method       : "get",
			//parameters   : params,
			//onLoaded     : function(){
			//	// 更新イメージをチェック中にする
			//	var imgUpd = $("img_access");
			//	imgUpd.src   = IMG_SRC_ACCESS_NOW;
			//	imgUpd.alt   = getLocalizedString("IMG_ALT_ACCESS_NOW");
			//	imgUpd.title = getLocalizedString("IMG_ALT_ACCESS_NOW");
			//},
			//onComplete   : showUpdateSuggest,
			asynchronous : false,
			onFailure    : updateSuggestError,
			onException  : updateSuggestException
		}
	);
*/

	// アクセス
	var resTxt = null;
	try{
		// Ajax通信
		// 非同期だとうまく動作しない
		resTxt = ajax.gets(param);

	}catch(ex){
		updateSuggestError(ex);
		return;
	}

	// レスポンスを作成
/*
	var updSuggestRes = new Ajax.Response(updSuggestReq);
	showUpdateSuggest(updSuggestRes);
*/
	showUpdateSuggest(resTxt);
}

/**
 * サジェスト表示。
 *
 * @param resTxt レスポンスオブジェクト
 */
function showUpdateSuggest(resTxt){
	// 更新チェックデータの取得
	var updData = null;
	if(resTxt != null){
		try{
			//updData = resTxt.evalJSON();
			updData = JSON.parse(resTxt);

		}catch(ex){
			updateSuggestException(ex);
			return;
		}
	}

	// 結果取得失敗
	if(updData == null || updData.length < 2){
		// 更新イメージを元に戻す
		showSuggestNone();
		return;
	}

	// 対象サジェスト取得なし
	var targetKeyward = updData[0];
	var suggestList   = updData[1];
	if(suggestList == null || suggestList <= 0){
		// 更新イメージを元に戻す
		showSuggestNone();
		return;
	}

	// サジェスト表示
	showSuggest(suggestList);
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function updateSuggestError(res){
	showSuggestNone();
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function updateSuggestException(res, ex){
	showSuggestNone();
}

/**
 * 検索入力(確定前)。
 *
 * @param event イベント
 */
function doInputSearchBefore(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		// 処理続行
	}

	// コントロールが押されている
	if(event.ctrlKey){
		// 処理続行
	}

	// シフトが押されている
	if(event.shiftKey){
		// 処理続行
	}

	switch(key){
		// エスケープ、左右キー
		case 27:
		case 39:
		case 37:
			// 検索ボックスへフォーカスを移す
			clearSuggest();

			$("txt_search").focus();
			break;

		// 上キー
		case 38:
			// サジェスト検索ボックスの先頭へフォーカスを移す
			var selSuggest = $("sel_suggest");
			if(selSuggest.className != "hide"){
				flgSelSuggest = true;

				if(selSuggest.selectedIndex <= -1){
					selSuggest.selectedIndex = selSuggest.length - 1;
					selSuggest.focus();
				}
			}
			break;

		// 下キー
		case 40:
			// サジェスト検索ボックスの最後へフォーカスを移す
			var selSuggest = $("sel_suggest");
			if(selSuggest.className != "hide"){
				flgSelSuggest = true;

				if(selSuggest.selectedIndex <= -1){
					selSuggest.selectedIndex = 0;
					selSuggest.focus();
				}
			}
			break;

		// エンター
		case 13:
		default:
			break;
	}
}

/**
 * 検索入力(確定後)。
 *
 * @param event イベント
 */
function doInputSearchAfter(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		// 何もしない
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		// 何もしない
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		// 何もしない
		return;
	}

	switch(key){
		// エスケープ、左右キー
		case 27:
		case 39:
		case 37:
			// 何もしない
			break;

		// エンター、上下キー
		case 13:
		case 38:
		case 40:
		default:
			// サジェスト検索
			doSuggestSearch();
			break;
	}
}

/**
 * 検索入力(確定後)。
 *
 * @param event イベント
 */
function doInputSearchAfter2(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		// 何もしない
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		// 何もしない
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		// 何もしない
		return;
	}

	switch(key){
		// エンター
		case 13:
			clearSuggest();
			doSearch();
			break;

		// 上下キー
		// エスケープ、左右キー
		case 27:
		case 39:
		case 37:
		case 38:
		case 40:
		default:
			break;
	}
}

/**
 * サジェスト検索入力(確定前)。
 *
 * @param event イベント
 */
function doInputSuggestBefore(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		// 処理続行
	}

	// コントロールが押されている
	if(event.ctrlKey){
		// 処理続行
	}

	// シフトが押されている
	if(event.shiftKey){
		// 処理続行
	}

	switch(key){
		// エスケープ、左右キー
		case 27:
		case 39:
		case 37:
			// 検索ボックスへフォーカスを移す
			clearSuggest();

			$("txt_search").focus();
			break;

		// 上キー
		case 38:
			// 検索ボックスへフォーカスを移す
			var selSuggest = $("sel_suggest");
			if(selSuggest.className != "hide"){
				if(selSuggest.selectedIndex == 0){

					$("txt_search").focus();
				}
			}
			break;

		// 下キー
		case 40:
			// サジェスト検索ボックスの最後へフォーカスを移す
			var selSuggest = $("sel_suggest");
			if(selSuggest.className != "hide"){
				if(selSuggest.selectedIndex == (selSuggest.length - 1)){

					$("txt_search").focus();
				}
			}
			break;

		// エンター
		case 13:
		default:
			break;
	}
}

/**
 * サジェスト検索入力(確定後)。
 *
 * @param event イベント
 */
function doInputSuggestAfter(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		// 何もしない
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		// 何もしない
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		// 何もしない
		return;
	}

	switch(key){
		// エスケープ、上下左右キー
		case 27:
		case 39:
		case 37:
		case 38:
		case 40:
			// 何もしない
			break;

		// エンター
		case 13:
			doSuggestSelect(event);
			break;

		default:
			break;
	}
}

/**
 * サジェスト検索選択。
 *
 * @param event イベント
 */
function doSuggestSelect(event){
	if(event == null){
		event = window.event;
	}

	// サジェストキーワードの設定
	var keyward = null;
	if(event.srcElement != null){
		keyward = event.srcElement.value;
	} else if(event.target != null){
		keyward = event.target.value;
	}
	$("txt_search").value = keyward;

	// 検索ボックスへフォーカスを移す
	clearSuggest();

	// 検索実行
	doSearch();
}

/**
 * 検索エンジンの選択。
 */
function setSearchEngine(){
	var imgSrc = $("sel_search_engine").value;
	$("img_search_engine").src   = SEARCH_LIST.engine[imgSrc].icon;
	$("img_search_engine").alt   = SEARCH_LIST.engine[imgSrc].dispName
		+ getLocalizedString("MSG_SEARCH_ENGINE");
	$("img_search_engine").title = SEARCH_LIST.engine[imgSrc].dispName
		+ getLocalizedString("MSG_SEARCH_ENGINE");

	// 検索ボックスをオンフォーカスにする
	setSuggestBlur();
	$("txt_search").focus();
	$("txt_search").select();
}

/**
 * 検索ボックスのオンフォーカス。
 */
function setSearchFocus(){
	$("txt_search").className = "";

	initOnFlyout();
}

/**
 * 検索ボックスのオフフォーカス。
 */
function setSearchBlur(){
	var index = settingData.bg.substring(settingData.bg.length - 1);
	$("txt_search").className = "onInput" + index;

	// サジェスト表示のクリア
	if(!flgSelSuggest){
		if(isDashboard()){
			// dashboard対応
			return;
		}

		clearSuggest();
	}
}

/**
 * サジェスト検索ボックスのオンフォーカス。
 */
function setSuggestFocus(){
	flgSelSuggest = true;
}

/**
 * サジェスト検索ボックスのオフフォーカス。
 */
function setSuggestBlur(){
	flgSelSuggest = false;

	// サジェスト表示のクリア
	clearSuggest();
}

/**
 * 設定画面が表示されたとき。
 */
function doSetting(){
	// 特になし
}

/**
 * 設定画面が閉じられた時。
 */
function doSettingClosed(){
	// 設定情報の読込み
	readData();

	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * フォーカス設定。
 */
function setFocus(){
	// ボタンが連打できないようにする
	$("div_searchbox").focus();
}

/**
 * スライドバーにドックされたとき。
 */
function showOnDoc(){
	$("div_searchbox").className = settingData.bg;

	var index = settingData.bg.substring(settingData.bg.length - 1);
	$("sel_search_engine").className = "onInput" + index;
	$("txt_search").className        = "onInput" + index;
	$("btn_search").className        = "btn_search" + index;

	$("img_search_engine").src
		= SEARCH_LIST.engine[settingData.searchEngineDefault].icon;
	$("img_search_engine").alt
		= SEARCH_LIST.engine[settingData.searchEngineDefault].dispName
		+ getLocalizedString("MSG_SEARCH_ENGINE");
	$("img_search_engine").title
		= SEARCH_LIST.engine[settingData.searchEngineDefault].dispName
		+ getLocalizedString("MSG_SEARCH_ENGINE");

	for(var cnt = 0 ; cnt < SEARCH_LIST.name.length ; cnt++){
		var flgSelect = false;
		var name      = SEARCH_LIST.name[cnt];
		if(name == settingData.searchEngineDefault){
			flgSelect = true;
		}
		$("sel_" + name).selected = flgSelect;
	}

	clearSuggest();
	flgOnDoc = true;
}

/**
 * スライドバーからアンドックされたとき。
 */
function showUnDoc(){
	$("div_searchbox").className = "unDoc";

	var index = settingData.bg.substring(settingData.bg.length - 1);
	$("sel_search_engine").className = "onInput" + index;
	$("txt_search").className        = "onInput" + index;
	$("btn_search").className        = "btn_search" + index;

	$("img_search_engine").src
		= SEARCH_LIST.engine[settingData.searchEngineDefault].icon;
	$("img_search_engine").alt
		= SEARCH_LIST.engine[settingData.searchEngineDefault].dispName
		+ getLocalizedString("MSG_SEARCH_ENGINE");
	$("img_search_engine").title
		= SEARCH_LIST.engine[settingData.searchEngineDefault].dispName
		+ getLocalizedString("MSG_SEARCH_ENGINE");

	for(var cnt = 0 ; cnt < SEARCH_LIST.name.length ; cnt++){
		var flgSelect = false;
		var name      = SEARCH_LIST.name[cnt];
		if(name == settingData.searchEngineDefault){
			flgSelect = true;
		}
		$("sel_" + name).selected = flgSelect;
	}

	clearSuggest();
	flgOnDoc = false;
}

/**
 * 設定情報の初期化。
 */
function initSettingData(){
	// 検索エンジン選択
	for(var cnt = 0 ; cnt < SEARCH_LIST.name.length ; cnt++){
		var name = SEARCH_LIST.name[cnt];
		$("sel_" + name).innerHTML = SEARCH_LIST.engine[name].dispName;
	}

	// 画面表示の設定
	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * 更新チェックするか。
 *
 * @return 更新チェックするときにはtrue
 */
function isCheckUpdate(){
	var flgChkUpd = false;

	// 未チェックだったら必ずtrue
	if(settingData.chkUpdTime <= 0){
		return true;
	}

	// 更新イメージ表示中だったら必ずtrue
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		return true;
	}

	var nowDate   = new Date();
	var nextDate  = new Date(settingData.chkUpdTime);

	// 1ヶ月後を設定
	nextDate.setMonth(nowDate.getMonth() + UPDATE_INTERVAL_MONTH);

	if(nowDate.getTime() > nextDate.getTime()){
		// 更新チェックを行う
		flgChkUpd = true;
	}

	return flgChkUpd;
}

/**
 * 更新なしイメージの設定。
 */
function showUpdateNon(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NON;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NON");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NON");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NON + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" border="0">';
	}
}

/**
 * チェック中イメージの設定。
 */
function showUpdateNow(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NOW;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NOW + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" border="0">';
	}
}

/**
 * 更新イメージの設定。
 */
function showUpdate(){
	var imgUpd = $("img_upd");
	imgUpd.src   = IMG_SRC_UPDATE;
	imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE");
	imgUpd.title = getLocalizedString("IMG_ALT_UPDATE");

	var aUpd = $("a_upd");
	if(aUpd == null){
		// dashboard対応
		var onclickFnuc = "";
		if(isDashboard()){
			onclickFnuc = ' onclick="window.widget.openURL(this.href); return false;"';
		} // if(isDashboard())

		var divUpd = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML = '<a id="a_upd" href="' + settingData.chkUpdUrl +'"' + onclickFnuc + '>' + imgUpdHtml + '</a>';

	} else {
		aUpd.href = settingData.chkUpdUrl;
	}
}

/**
 * 更新チェック。
 * 更新チェックはPC起動時または1日毎に行う。
 */
function checkUpdate(){
	if(updChkIid != null){
		clearTimeout(updChkIid);
		updChkIid = null;
	}

	try{
		doCheckUpdate();
	}catch(ex){
	}
	updChkIid = setTimeout('checkUpdate()', UPDATE_CEHCK_INTERVAL_TIME);
}

/**
 * 更新表示。
 */
function doCheckUpdate(){
	// 更新イメージの初期設定
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}

	// 更新チェックするか
	var flgChkUpd = isCheckUpdate();
	if(!flgChkUpd){

		// 今回は更新チェックを行わない
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		return;
	}

	// 更新イメージをチェック中にする
	showUpdateNow();

	// Firefox対応
	try{
		if(netscape){
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		}
	}catch (ex){
	}

	var updateUrl = null;
	if(isOpera()){
		updateUrl = OPERA_UPDATE_URL;

	} else if(isDashboard()){
		updateUrl = DASHBOARD_UPDATE_URL;

	} else if(isSBM()){
		updateUrl = SBM_UPDATE_URL;

	} else {
		updateUrl = VISTA_UPDATE_URL;
	}

/*
	// 非同期だとうまく動作しない
	var chkUpdReq = new Ajax.Request(
		updateUrl, {
			method       : "get",
			parameters   : "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime(),
//			onLoaded     : function(){
//				// 更新イメージをチェック中にする
//				var imgUpd = $("img_upd");
//				imgUpd.src   = IMG_SRC_UPDATE_NOW;
//				imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
//				imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");
//			},
			//onComplete   : showCheckUpdate,
			asynchronous : false,
			onFailure    : checkUpdateError,
			onException  : checkUpdateException
		}
	);
*/

	// 最新バージョンの取得
	var parameters = "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime();
	var resTxt     = null;
	try{
		// Ajax通信
		// 非同期だとうまく動作しない
		resTxt = ajax.gets(updateUrl + "?" + parameters);

	}catch(ex){
		checkUpdateError(ex);
		return;
	}

	// レスポンスを作成
/*
	var chkUpdRes = new Ajax.Response(chkUpdReq);
	showCheckUpdate(chkUpdRes);
*/
	showCheckUpdate(resTxt);
}

/**
 * 更新表示。
 *
 * @param resTxt レスポンスオブジェクト
 */
function showCheckUpdate(resTxt){
	var flgUpd = false;

	// 更新チェックデータの取得
	var chkUpdData = null;
	if(resTxt != null){
		try{
			//chkUpdData = resTxt.evalJSON();
			chkUpdData = JSON.parse(resTxt);

		}catch(ex){
			checkUpdateException(ex);
			return;
		}
	}

	if(
		chkUpdData == null
		|| chkUpdData[GADGET_NAME] == null
	){
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// バージョンチェック
	if(nowVer != chkUpdData[GADGET_NAME].version){
		var nowVerList = nowVer.split(".");
		var updVerList = chkUpdData[GADGET_NAME].version.split(".");
		for(var cnt = 0 ; cnt < nowVerList.length ; cnt++){
			if(cnt >= updVerList.length){
				break;
			}

			var nowVerSub = parseInt(nowVerList[cnt]);
			var updVerSub = parseInt(updVerList[cnt]);
			if(nowVerSub < updVerSub){
				flgUpd = true;
				break;

			} else if(nowVerSub > updVerSub){
				break;
			}
		} // for(var cnt = 0 ; cnt < nowVerList.length ; cnt++)
	}

	// 更新イメージ設定
	if(flgUpd){
		settingData.chkUpdUrl = chkUpdData[GADGET_NAME].url;

		// 更新イメージにする
		showUpdate();

	} else {
		settingData.chkUpdUrl = null;

		// 更新なしイメージにする
		showUpdateNon();
	}


	// 更新チェック日付の更新
	settingData.chkUpdTime = new Date().getTime();
	writeData();
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateError(res){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateException(res, ex){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * バージョン情報の取得。
 */
function getVersion(){
	var ver = "";

	try{
		//ver = System.Gadget.version;
		ver = VERSION;

	}catch(ex){
	}

	return ver;
}

/**
 * サジェスト表示。
 */
function initOnFlyout(){
	// サジェスト検索off
	if(!settingData.suggest){
		// 何もしない
		return;
	}

	// 対象サジェストURLなし
	var searchEndine = $("sel_search_engine").value;
	var suggestUrl   = SEARCH_LIST.engine[searchEndine].suggestUrl;
	if(suggestUrl == null || suggestUrl == ""){
		// 何もしない
		return;
	}

	if(!flgOnDoc || !settingData.flyout){
		return;
	}

	try{
		// onDocのときのみフライアウトで表示
		if(!System.Gadget.Flyout.show){
			flgSelSuggest = true;
			System.Gadget.Flyout.show = true;

		} else {
			// フライアウトの更新
			flgSelSuggest = true;
			flyoutInit();
		}

	}catch(ex){
	}
}

/**
 * サジェスト表示。
 */
function showOnFlyout(){
	if(flgOnDoc || settingData.flyout){
		try{
			// onDocのときのみフライアウトで表示
			if(!System.Gadget.Flyout.show){
				flgSelSuggest = true;
			}

			// フライアウトの更新
			flgSelSuggest = true;
			flyoutDoShow();
			return;
		}catch(ex){
		}
	}

	// opera widget対応
	var selSuggest = $("sel_suggest");

	// opera widget対応
	if(isOpera()){
		// サジェスト表示のサイズ調整
		window.resizeTo(
			WINDOW_WIDTH,
			WINDOW_HEIGHT + (suggestHeight * (selSuggest.size + 2))
		);
		document.body.style.height
			= WINDOW_HEIGHT + (suggestHeight * (selSuggest.size + 2)) + "px";

	} else {
		// サジェスト表示のサイズ調整
		window.resizeTo(
			WINDOW_WIDTH,
			WINDOW_HEIGHT + (suggestHeight * (selSuggest.size))
		);
		document.body.style.height
			= WINDOW_HEIGHT + (suggestHeight * (selSuggest.size)) + "px";
	}

	// サジェスト表示
	var index = settingData.bg.substring(settingData.bg.length - 1);
	selSuggest.className = "onInput" + index;
}

/**
 * サジェスト表示のクリア。
 */
function showUnFlyout(){
	if(flgOnDoc || settingData.flyout){
		try{
			var searchEndine = $("sel_search_engine").value;
			var suggestUrl   = SEARCH_LIST.engine[searchEndine].suggestUrl;

			// onDocのときのみフライアウトで表示
			if(
				settingData.suggest
				&& (suggestUrl != null && suggestUrl != "")
			){
				flyoutInit();

			} else {
				System.Gadget.Flyout.show = false;
				flgSelSuggest = false;
			}

			return;
		}catch(ex){
		}
	}

	if($("sel_suggest").className == "hide"){
		// 何もしない
		return;
	}

	// opera widget対応
	// サジェスト表示のサイズ調整
	window.resizeTo(WINDOW_WIDTH, WINDOW_HEIGHT);
	document.body.style.height = WINDOW_HEIGHT + "px";

	// サジェスト表示のクリア
	$("sel_suggest").className = "hide";
}

/**
 * 検索実行。
 *
 * @param param 検索パラメータ
 */
function showSearch(param){
	try{
		if(isOpera()){
			// opera widget対応
			window.open(param);
			tmpKeyInput = $("txt_search").value;

		} else if(isDashboard()){
			widget.openURL(param);

		} else {
			System.Shell.execute(param);
		}
	}catch(ex){
	}
}

/**
 * 設定情報の読込み。
 *
 * @return 読込んだ設定情報
 */
function getReadData(){
	var readValue = null;

	try{
		if(!isVista()){
			readValue = widget.preferenceForKey(SETTING_NAME);

		} else {
			readValue = System.Gadget.Settings.readString(SETTING_NAME);
		}
	}catch(ex){
	}

	var readData_ = null;
	if(readValue != null && readValue != ""){
		try{
			//readData_ = readValue.evalJSON();
			readData_ = JSON.parse(readValue);

		}catch(ex){
		}
	}

	return readData_;
}

/**
 * 設定情報の読込み。
 */
function readData(){
	var readData_ = getReadData();

	if(readData_ != null && readData_ != ""){
		settingData = readData_;
	}

	if(isMobile()){
		settingData.suggest = false;
	}
}

/**
 * 設定情報の書込み。
 *
 * @param writeData 書込む設定情報
 */
function setWriteData(writeData){
	try{
		//var writeValue = Object.toJSON(writeData);
		var writeValue = JSON.stringify(writeData);

		if(!isVista()){
			widget.setPreferenceForKey(writeValue, SETTING_NAME);

		} else {
			System.Gadget.Settings.writeString(SETTING_NAME, writeValue);
		}
	}catch(ex){
	}
}

/**
 * 設定情報の書込み。
 */
function writeData(){
	setWriteData(settingData);
}

/**
 * 初期処理。
 */
function init(){
	setEventListener();
	setGadgetEventListener();
	flyoutSetGadgetEventListener();
	readData();

	// ソフトバンクモバイルかの判定
	if(!isSBM()){

		// 設定画面の読込み
		$("if_setting").src = "searchbox-setting.html";

	} else {
		setMobilePhone();
	}

	// 画面表示の設定
	setLocalized(settingData.lang);
	initSettingData();
	if(FLG_UPDATE){
		checkUpdate();
	}
	setFocus();
}

/**
 * イベントリスナーの設定。
 */
function setEventListener(){
	// 検索エンジン
	$("img_search_engine").onclick  = function(){ setSuggestBlur(); $("sel_search_engine").focus(); };
	$("sel_search_engine").onchange = setSearchEngine;

	// 検索ボックス 
	$("txt_search").onfocus    = setSearchFocus;
	$("txt_search").onblur     = setSearchBlur;
	$("txt_search").onkeydown  = doInputSearchBefore;
	$("txt_search").onkeyup    = doInputSearchAfter;
	$("txt_search").onkeypress = doInputSearchAfter2;
	$("btn_search").onclick    = function(){ clearSuggest(); doSearch(); };

	// サジェスト検索ボックス
	$("sel_suggest").onfocus   = setSuggestFocus;
	$("sel_suggest").onblur    = setSuggestBlur;
	$("sel_suggest").onkeydown = doInputSuggestBefore;
	$("sel_suggest").onkeyup   = doInputSuggestAfter;
	$("sel_suggest").onclick   = doSuggestSelect;
}

/**
 * ガジェットイベントリスナーの設定。
 */
function setGadgetEventListener(){
	try{
		flgOnDoc = System.Gadget.docked;

		// ドックの状態設定
		System.Gadget.onDock   = showOnDoc;
		System.Gadget.onUndock = showUnDoc;

		// 設定画面の設定
		System.Gadget.settingsUI        = "searchbox-setting.html";
		System.Gadget.onShowSettings    = doSetting;
		System.Gadget.onSettingsClosed  = function(){ doSettingClosed(); setFocus(); };

		// フライアウトjsの設定
		var flyoutScript     = document.createElement('script');
		flyoutScript.charset = "utf-8";
		flyoutScript.src     = "js/searchbox-flyout.js";
		document.body.appendChild(flyoutScript);

		// フライアウト画面の設定
		System.Gadget.Flyout.file = "searchbox-flyout.html";

	}catch(ex){
		// ツールバーの表示
		$("td_setting").className = "";

		//// 最大化ボタン(unDoc)
		//$("btn_max").onclick = function(){
		//	if(flgOnDoc){
		//		showUnDoc();
		//	} else {
		//		showOnDoc();
		//	}
		//};

		// 設定ボタン
		if(!!window.JSON){
			$("btn_conf").onclick = function(){
				doSetting();
				$("if_setting").className = "";
				//$("btn_max").className    = "hide";
				$("div_searchbox").className  = "hide";

				if(isMobile()){
					window.resizeTo(WINDOW_SETTING_MOBILE_WIDTH, WINDOW_SETTING_MOBILE_HEIGHT);
				} else {
					window.resizeTo(WINDOW_SETTING_WIDTH, WINDOW_SETTING_HEIGHT);
				} // if(isMobile())
			}

		} else {
			$("btn_conf").className = "hide";
		}

		if(isOpera()){
				// 閉じるボタン
				$("btn_close").onclick = function(){
					window.close();
				};

		} else {
			$("btn_close").className = "hide";
		}

		// opera widget対応
		if(isOpera()){
			// キー入力監視
			setInterval("checkKeyInput()", suggestTime * 2);
		}
	}
}

/**
 * ガジェットイベントリスナーの設定。
 */
function flyoutSetGadgetEventListener(){
	try{
		// フライアウトの設定
		System.Gadget.Flyout.onShow = flyoutInit;
		System.Gadget.Flyout.onHide = flyoutDoHide;

	}catch(ex){
	}
}

var tmpKeyInput = null;

/**
 *キー入力監視。
 */
function checkKeyInput(){
	var keyward = $("txt_search").value;
	if(tmpKeyInput == null || tmpKeyInput != keyward){
		tmpKeyInput = keyward;
		doSuggestSearch();
	}
}

/**
 * ソフトバンクモバイル用設定。
 */
function setMobilePhone(){
	FLG_UPDATE = false;
	$("div_toolbar").className = "hide";

	settingData.suggest = false;

	$("txt_search").className = "";
	$("txt_search").onfocus   = null;
	$("txt_search").onblur    = null;

	$("img_search_engine").width  = "48px";
	$("img_search_engine").height = "48px";
}

// 初期処理
document.body.onload = init();

